% GO4BALTIC - AES choice 2017-04-07

clear all
clc

%% ****************************  loading data  ****************************

global B_backup; % this one is for storing B in case iterations are interrupted with ctrl-c

EstimOpt.fnameinput = ('data_4_long_ALL.mat');
DATA = load(EstimOpt.fnameinput);

% % Explode ranking data:
% % Prepare missing responses indicator:
% ANS_tmp = reshape(DATA.ANS,[4,8,size(DATA.ANS,1)/4/8]);
% ANS_tmp = ~any(ANS_tmp==1,1) | ~any(ANS_tmp==2,1) | ~any(ANS_tmp==3,1) | ~any(ANS_tmp==4,1);
% ANS_tmp = repmat(ANS_tmp,[4,1,1]);
% DATA.Missing = ANS_tmp(:);
%
% fields = fieldnames(DATA);
% for i = 1:numel(fields)
%     tmp = DATA.(fields{i});
%     tmp = reshape(tmp,[4,8,length(tmp)/4/8,size(tmp,2)]);
%     tmp = repmat(tmp,[3,1,1,1]);
%     DATA.(fields{i}) = reshape(tmp,[size(tmp,1)*size(tmp,2)*size(tmp,3),size(tmp,4)]);
% end
% clear tmp fields i
% DATA.nalt = repmat([4 4 4 4 3 3 3 3 2 2 2 2]',[length(DATA.CT)/12,1]);
% DATA.Rank = zeros(size(DATA.CT));
% DATA.Rank(DATA.nalt==4 & DATA.ANS==1) = 1;
% DATA.Rank(DATA.nalt==3 & DATA.ANS==2) = 1;
% DATA.Rank(DATA.nalt==2 & DATA.ANS==3) = 1;
%
% DATA.MissingInd = zeros(size(DATA.CT));
% DATA.MissingInd(DATA.nalt==3 & DATA.ANS==1) = 1;
% DATA.MissingInd(DATA.nalt==2 & (DATA.ANS==1 | DATA.ANS==2)) = 1;
%
% DATA.Missing(DATA.MissingInd == 1) = 1;


%% ****************************  data transformations  ****************************

% DATA.SQ = DATA.ALT == 4;

% DATA.Missing(isnan(DATA.Missing)) = 0;

DATA.DK = DATA.Country == 4;
DATA.EE = DATA.Country == 5;
DATA.FI = DATA.Country == 3;
DATA.PL = DATA.Country == 1;
DATA.SE = DATA.Country == 2;

countries = {'DK','EE','FI','PL','SE'};

DATA.Subsidy = DATA.Subsidy;
DATA.Subsidy(DATA.DK) = DATA.Subsidy(DATA.DK)*0.13;
DATA.Subsidy(DATA.PL) = DATA.Subsidy(DATA.PL)/4;
DATA.Subsidy(DATA.SE) = DATA.Subsidy(DATA.SE)/10;

% Q1c_1  How large is the farmed area at your holding that you (yourself, your family, the cooperative or corporation) managed (owned and leased) during the season 2015/16?
% dstats(DATA.Q1c_1,1)
DATA.ha_managed = DATA.Q1c_1 / 100; % (in 100 ha)

% Q1c_2 How large is the farmed area at your holding that you (yourself, your family, the cooperative or corporation) leased during the season 2015/16?
% dstats(DATA.Q1c_2,1)
DATA.ha_leased = DATA.Q1c_2 / 100; % (in 100 ha)

% DATA.ha_total = DATA.ha_owned + DATA.ha_leased;

% dstats(DATA.Q7b_1,1)

DATA.Q7b_2(22593:22624) = 180;

% dstats(DATA.Q7b_3,1)
% dstats(DATA.Q7b_4,1)
% dstats(DATA.Q7b_5,1)
% dstats(DATA.Q7b_7,1)

DATA.ha_arable = DATA.Q7b_2 + DATA.Q7b_3 + DATA.Q7b_4 + DATA.Q7b_5 + DATA.Q7b_7;
% dstats(DATA.ha_arable,1)

% Q1f Do you consider your farm holding as livestock, crop, or mixed farm (defined as the production generating the largest share of income)?
% 1 "Livestock farm (largest share of income from livestock)"
% 2 "Crop farm (no significant income from livestock)"
% 3 "Mixed farm (about equal income from livestock and crops)"
% dstats(DATA.Q1f,1)
DATA.type_livestock = DATA.Q1f == 1; %31
DATA.type_crop = DATA.Q1f == 2; % 43
DATA.type_mixed = DATA.Q1f == 3; % 27

% Q1g Do you produce livestock at the farm?
% 1 "Yes"
% 2 "No"
% dstats(DATA.Q1g,1)

% Q4a Denmark
% Q4a What is the annual gross margin from your farm before tax and interest? (The gross margin from your farming activities is the income from selling crops, livestock, milk etc. minus the variable costs, i.e. feedstuffs, pesticides, fertilisers, seeds, fuels, machine station etc. The gross margin is the rest that you have to cover own /family salaries, tax, deficits and interests.
% 1 "Under 30000 kr."
% 2 "30000 - 59999 kr."
% 3 "60000 - 114999 kr."
% 4 "115000 - 224999 kr."
% 5 "225000 - 374999 kr."
% 6 "375000  559.000 kr."
% 7 "560.000  999.999 kr"
% 8 "1.000.000  1.999.999 kr"
% 9 "2.000.000  2.999.999 kr"
% 10 "3.000.000  3.9999.999 kr"
% 11 "4.000.000  4.999.999 kr"
% 12 "5.000.000 6.999.999 kr"
% 13 "7.000.000  9.999.999 kr"
% 14 "10.000.000 14.999.999 kr"
% 15 "15.000.000  19.999.999 kr"
% 16 "20.000.000 kr og derover"
% 17 Refuse
% 18 Don't know
DATA.SGM = zeros(size(DATA.RespID));
DATA.SGM(DATA.DK == 1 & DATA.Q4a == 1) = 30000;
DATA.SGM(DATA.DK == 1 & DATA.Q4a == 2) = 45000;
DATA.SGM(DATA.DK == 1 & DATA.Q4a == 3) = 87500;
DATA.SGM(DATA.DK == 1 & DATA.Q4a == 4) = 170000;
DATA.SGM(DATA.DK == 1 & DATA.Q4a == 5) = 300000;
DATA.SGM(DATA.DK == 1 & DATA.Q4a == 6) = 467500;
DATA.SGM(DATA.DK == 1 & DATA.Q4a == 7) = 780000;
DATA.SGM(DATA.DK == 1 & DATA.Q4a == 8) = 1500000;
DATA.SGM(DATA.DK == 1 & DATA.Q4a == 9) = 2500000;
DATA.SGM(DATA.DK == 1 & DATA.Q4a == 10) = 3500000;
DATA.SGM(DATA.DK == 1 & DATA.Q4a == 11) = 4500000;
DATA.SGM(DATA.DK == 1 & DATA.Q4a == 12) = 5500000;
DATA.SGM(DATA.DK == 1 & DATA.Q4a == 13) = 8000000;
DATA.SGM(DATA.DK == 1 & DATA.Q4a == 14) = 12500000;
DATA.SGM(DATA.DK == 1 & DATA.Q4a == 15) = 17500000;
DATA.SGM(DATA.DK == 1 & DATA.Q4a == 16) = 20000000;
DATA.SGM(DATA.DK == 1) = DATA.SGM(DATA.DK == 1) * 0.13;
DATA.SGM_NaN = zeros(size(DATA.SGM));
DATA.SGM_NaN(DATA.DK == 1 & DATA.Q4a == 17) = 1;
DATA.SGM_NaN(DATA.DK == 1 & DATA.Q4a == 18) = 1;

% Q4a Estonia
% Q4a What is the annual gross margin from your farm before tax and interest? (The gross margin from your farming activities is the income from selling crops, livestock, milk etc. minus the variable costs, i.e. feedstuffs, pesticides, fertilisers, seeds, fuels, machine station etc. The gross margin is the rest that you have to cover own /family salaries, tax, deficits and interests.
% 1 "Less than 4000 EURO"
% 2 "4000-7999 EURO"
% 3 "8000-14999 EURO"
% 4 "15000-29999 EURO "
% 5 "30000-49999 EURO"
% 6 "50000-75000 EURO"
% 7 ">75000 EURO"
% 8 "Do not wish to answer"
% 9 "Don't know"
DATA.SGM(DATA.EE == 1 & DATA.Q4a == 1) = 4000;
DATA.SGM(DATA.EE == 1 & DATA.Q4a == 2) = 6000;
DATA.SGM(DATA.EE == 1 & DATA.Q4a == 3) = 11500;
DATA.SGM(DATA.EE == 1 & DATA.Q4a == 4) = 22500;
DATA.SGM(DATA.EE == 1 & DATA.Q4a == 5) = 40000;
DATA.SGM(DATA.EE == 1 & DATA.Q4a == 6) = 62500;
DATA.SGM(DATA.EE == 1 & DATA.Q4a == 7) = 75000;
DATA.SGM_NaN(DATA.EE == 1 & DATA.Q4a == 8) = 1;
DATA.SGM_NaN(DATA.EE == 1 & DATA.Q4a == 9) = 1;


% Q4a Finland
% Q4a What is the annual gross margin from your farm before tax and interest? (The gross margin from your farming activities is the income from selling crops, livestock, milk etc. minus the variable costs, i.e. feedstuffs, pesticides, fertilisers, seeds, fuels, machine station etc. The gross margin is the rest that you have to cover own /family salaries, tax, deficits and interests.
% 1 "Less than 4000 EURO"
% 2 "4000-7999 EURO"
% 3 "8000-14999 EURO"
% 4 "15000-29999 EURO "
% 5 "30000-49999 EURO"
% 6 "50000-75000 EURO"
% 7 ">75000 EURO"
% 8 "Do not wish to answer"
% 9 "Don't know"
DATA.SGM(DATA.FI == 1 & DATA.Q4a == 1) = 4000;
DATA.SGM(DATA.FI == 1 & DATA.Q4a == 2) = 6000;
DATA.SGM(DATA.FI == 1 & DATA.Q4a == 3) = 11500;
DATA.SGM(DATA.FI == 1 & DATA.Q4a == 4) = 22500;
DATA.SGM(DATA.FI == 1 & DATA.Q4a == 5) = 40000;
DATA.SGM(DATA.FI == 1 & DATA.Q4a == 6) = 62500;
DATA.SGM(DATA.FI == 1 & DATA.Q4a == 7) = 75000;
DATA.SGM_NaN(DATA.FI == 1 & DATA.Q4a == 8) = 1;
DATA.SGM_NaN(DATA.FI == 1 & DATA.Q4a == 9) = 1;

% Q4a Poland
% Q4a What is the annual gross margin from your farm before tax and interest? (The gross margin from your farming activities is the income from selling crops, livestock, milk etc. minus the variable costs, i.e. feedstuffs, pesticides, fertilisers, seeds, fuels, machine station etc. The gross margin is the rest that you have to cover own /family salaries, tax, deficits and interests.
% 1 "Mniej ni? 16 tysi?cy z? "
% 2 "16 000 - 31 999 z?"
% 3 "32 000 - 59 999 z?"
% 4 "60 000 - 119 999 z?"
% 5 "120 000 - 199 999 z?"
% 6 "200 000 - 300 000 z?"
% 7 "300 000 - 400 000 z? "
% 8 "Ponad 400 000 z?"
% 9 "Odmowa odpowiedzi "
% 10 "Nie wiem"
DATA.SGM(DATA.PL == 1 & DATA.Q4a == 1) = 16000;
DATA.SGM(DATA.PL == 1 & DATA.Q4a == 2) = 24000;
DATA.SGM(DATA.PL == 1 & DATA.Q4a == 3) = 46000;
DATA.SGM(DATA.PL == 1 & DATA.Q4a == 4) = 90000;
DATA.SGM(DATA.PL == 1 & DATA.Q4a == 5) = 160000;
DATA.SGM(DATA.PL == 1 & DATA.Q4a == 6) = 250000;
DATA.SGM(DATA.PL == 1 & DATA.Q4a == 7) = 350000;
DATA.SGM(DATA.PL == 1 & DATA.Q4a == 8) = 400000;
DATA.SGM(DATA.PL == 1) = DATA.SGM(DATA.PL == 1) / 4;
DATA.SGM_NaN(DATA.PL == 1 & DATA.Q4a == 9) = 1;
DATA.SGM_NaN(DATA.PL == 1 & DATA.Q4a == 10) = 1;

% Q4a Sweden
% Q4a What is the annual gross margin from your farm before tax and interest? (The gross margin from your farming activities is the income from selling crops, livestock, milk etc. minus the variable costs, i.e. feedstuffs, pesticides, fertilisers, seeds, fuels, machine station etc. The gross margin is the rest that you have to cover own /family salaries, tax, deficits and interests.
% 1 "Mindre n 40 000 kronor"
% 2 "40 000 - 79 999 kronor"
% 3 "80 000 - 149 999 kronor"
% 4 "150 000 - 299 999 kronor "
% 5 "300 000 - 499 999 kronor"
% 6 "500 000 - 749 999 kronor"
% 7 "750 000 - 1 000 000 kronor "
% 8 ">1 000 000 kroner"
% 9 "Vill inte svara"
% 10 "Vet ej"
DATA.SGM(DATA.SE == 1 & DATA.Q4a == 1) = 40000;
DATA.SGM(DATA.SE == 1 & DATA.Q4a == 2) = 60000;
DATA.SGM(DATA.SE == 1 & DATA.Q4a == 3) = 115000;
DATA.SGM(DATA.SE == 1 & DATA.Q4a == 4) = 225000;
DATA.SGM(DATA.SE == 1 & DATA.Q4a == 5) = 400000;
DATA.SGM(DATA.SE == 1 & DATA.Q4a == 6) = 625000;
DATA.SGM(DATA.SE == 1 & DATA.Q4a == 7) = 875000;
DATA.SGM(DATA.SE == 1 & DATA.Q4a == 8) = 1000000;
DATA.SGM(DATA.SE == 1) = DATA.SGM(DATA.SE == 1) / 10;
DATA.SGM_NaN(DATA.SE == 1 & DATA.Q4a == 9) = 1;
DATA.SGM_NaN(DATA.SE == 1 & DATA.Q4a == 10) = 1;

DATA.SGM = DATA.SGM / 100000;

% Q5 How many animals of each of the following categories do you currently have at the holding, measured as animal heads?
% Q5_1	Suckler cows
% Q5_2	Calves
% Q5_3	Dairy cows
% Q5_4	Heifers
% Q5_5	Bulls
% Q5_6	Sows
% Q5_7	Weaners
% Q5_8	Fattening pigs
% Q5_9	Minks
% Q5_10	Foxes
% Q5_11	Sheep
% Q5_12	Goats
% Q5_13	Horses
% Q5_14	Poultry

DATA.DJP = DATA.Q5_1*1 + DATA.Q5_2*0.225 + DATA.Q5_3*1 + DATA.Q5_4*1 + DATA.Q5_5*0.35 + DATA.Q5_6*0.07 + DATA.Q5_8*0.14 + ...
    DATA.Q5_9*0.0025 + DATA.Q5_10*0.025 + DATA.Q5_11*0.1 + DATA.Q5_12*0.15 + DATA.Q5_13*1.2 + DATA.Q5_14*0.005;
% dstats(DATA.DJP,1)
DATA.DJP = DATA.DJP/100;

DATA.DJP_0 = DATA.DJP == 0; % 37%

% 	Quota_Pig_Farm
% 	1 Pig Farm
% 	0 Not Pig Farm

% dstats(DATA.Quota_Pig_Farm,1)

DATA.Pig_Farm = DATA.Quota_Pig_Farm; % 26%

% 	Quota_Cow_Farm
% 	1 Cow Farm
% 	0 Not Cow Farm

DATA.Cow_Farm = DATA.Quota_Cow_Farm; % 38%

% Q6. Is your production certified as organic? 
% 1 "Yes, the whole farm production is certified as organic"
% 2 "Yes, part of the farm production is certified as organic, but part of it is certified as conventional"
% 3 "The farm is under conversion to organic production"
% 4 "No, none of the production is certified as organic"
% dstats(DATA.Q6,1)
DATA.organic_all = DATA.Q6==1; % 0.09
DATA.organic_part = DATA.Q6==2 | DATA.Q6==3; % 0.04

% 	Q23 We will now ask you if you have applied any of the following land use changes/measures at your farm. 
% Q23_1	1 "Buffer strips"
% Q23_2	2 "Establishment and preservation of wetlands "
% Q23_3	3 "Reduced fertilisation"
% Q23_4	4 "Set aside"
% Q23_5	5 "Avoiding application of fertiliser and manure at high risk times and places"
% Q23_6	6 "Soil cover by crops in winter period"
% Q23_7	7 "Catch crops"
% Q23_8	8 "Reduced tillage"
% Q23_9	9 "Reduce animal numbers at the farm holding"
% Q23_10	10 "Energy crops"
% Q23_11	11 "Afforestation"
% Q23_12	12 "None of these"

DATA.exp_buffer_strips = DATA.Q23_1==1;
DATA.exp_wetlands = DATA.Q23_2==2;
DATA.exp_red_fert = DATA.Q23_3==3;
DATA.exp_set_aside = DATA.Q23_4==4;
DATA.exp_fert_sens = DATA.Q23_5==5;
DATA.exp_winter_crops = DATA.Q23_6==6;
DATA.exp_catch_crops = DATA.Q23_7==7;
DATA.exp_red_till = DATA.Q23_8==8;
DATA.exp_red_animal = DATA.Q23_9==9;
DATA.exp_energy_crops = DATA.Q23_10==10;
DATA.exp_afforest = DATA.Q23_11==11;
DATA.exp_none = DATA.Q23_12==12;

% Q23b For how many hectares/livestock units were the following measures applied in 2016, to the best of your knowledge
% Q23b_1	Buffer strips
% Q23b_2	Establishment and preservation of wetlands
% Q23b_3	Reduced fertilisation
% Q23b_4	Set aside
% Q23b_5	Avoiding application of fertiliser and manure at high risk times and places
% Q23b_6	Soil cover by crops in winter period
% Q23b_7	Catch crops
% Q23b_8	Reduced tillage
% Q23b_9	Reduce animal numbers at the farm holding
% Q23b_10	Energy crops
% Q23b_11	Afforestation

 
% Q26 To what degree are you concerned about the following, please answer on a scale from 1 to 5, where 1 means not at all concerned and 5 means very concerned
% Loss of soil fertility
% 1 "1 Strongly disagree"
% 2 "2 Disagree"
% 3 "3 Neutral"
% 4 "4 Agree"
% 5 "5 Strongly agree"
% 6 "Don't know"
% Compacted soil
% 1 "1 Strongly disagree"
% 2 "2 Disagree"
% 3 "3 Neutral"
% 4 "4 Agree"
% 5 "5 Strongly agree"
% 6 "Don't know"
% Loss of soil nutrients
% 1 "1 Strongly disagree"
% 2 "2 Disagree"
% 3 "3 Neutral"
% 4 "4 Agree"
% 5 "5 Strongly agree"
% 6 "Don't know"
% The impact of fertilisers on water quality
% 1 "1 Strongly disagree"
% 2 "2 Disagree"
% 3 "3 Neutral"
% 4 "4 Agree"
% 5 "5 Strongly agree"
% 6 "Don't know"
% The impact of fertiliser on air quality
% 1 "1 Strongly disagree"
% 2 "2 Disagree"
% 3 "3 Neutral"
% 4 "4 Agree"
% 5 "5 Strongly agree"
% 6 "Don't know"
% The impact of fertiliser on nature
% 1 "1 Strongly disagree"
% 2 "2 Disagree"
% 3 "3 Neutral"
% 4 "4 Agree"
% 5 "5 Strongly agree"
% 6 "Don't know"
% Erosion
% 1 "1 Strongly disagree"
% 2 "2 Disagree"
% 3 "3 Neutral"
% 4 "4 Agree"
% 5 "5 Strongly agree"
% 6 "Don't know"


%% ****************************  model specification  ****************************

DATA.Y = (DATA.ANS == 1);
% DATA.Y = DATA.Rank;

DATA.Xa = [...
    DATA.ALT==1,DATA.ALT==2, DATA.ALT==3,...
    DATA.Area,...
    DATA.Length,...
    DATA.Termination==1,DATA.Termination==2,DATA.Advisory,...
    DATA.Subsidy];

EstimOpt.NamesA = {...
    'ASC - set aside';'ASC - catch crops';'ASC - fertilization';...
    'Area (%)';...
    'Length (years)';...
    'Termination with refund';'Termination without refund';'Advisory';...
    'Subsidy per ha (1000 EUR)'};

% DATA.Xa = [...
%     DATA.ALT==1,DATA.ALT==2, DATA.ALT==3,...
%     DATA.Area==5,DATA.Area==7,DATA.Area==10,DATA.Area==15,DATA.Area==25,...
%     DATA.Length==3,DATA.Length==5,DATA.Length==7,DATA.Length==10,DATA.Length==20,...
%     DATA.Termination==1,DATA.Termination==2,DATA.Advisory,...
%     DATA.Subsidy];
%
% EstimOpt.NamesA = {...
%     'ASC - set aside';'ASC - catch crops';'ASC - fertilization';...
%     'Area - 5 (vs. 1)';'Area - 7 (vs. 1)';'Area - 10 (vs. 1)';'Area - 15 (vs. 1)';'Area - 25 (vs. 1)';...
%     'Length - 3 (vs. 1)';'Length - 5 (vs. 1)';'Length - 7 (vs. 1)';'Length - 10 (vs. 1)';'Length - 20 (vs. 1)';...
%     'Termination with refund';'Termination without refund';'Advisory';...
%     'Subsidy per ha (1000 EUR)'};
%
% DATA.Xa = [...
%     DATA.ALT==1,DATA.Area.*(DATA.ALT==1),DATA.Length.*(DATA.ALT==1),(DATA.Termination==1).*(DATA.ALT==1),(DATA.Termination==2).*(DATA.ALT==1),DATA.Advisory.*(DATA.ALT==1),...
%     DATA.ALT==2,DATA.Area.*(DATA.ALT==2),DATA.Length.*(DATA.ALT==2),(DATA.Termination==1).*(DATA.ALT==2),(DATA.Termination==2).*(DATA.ALT==2),DATA.Advisory.*(DATA.ALT==2),...
%     DATA.ALT==3,DATA.Length.*(DATA.ALT==3),(DATA.Termination==1).*(DATA.ALT==3),(DATA.Termination==2).*(DATA.ALT==3),DATA.Advisory.*(DATA.ALT==3),...
%     DATA.Subsidy];
%
% EstimOpt.NamesA = {...
%     'ASC - set aside';'Area - set aside';'Length - set aside';'Termination with refund - set aside';'Termination without refund - set aside';'Advisory - set aside';...
%     'ASC - catch crops';'Area - catch crops';'Length - catch crops';'Termination with refund - catch crops';'Termination without refund - catch crops';'Advisory - catch crops';...
%     'ASC - fertilization';'Length - fertilization';'Termination with refund - fertilization';'Termination without refund - fertilization';'Advisory - fertilization';...
%     'Subsidy per ha (1000 EUR)'};
%
% DATA.Xa = [...
%     DATA.ALT==1,DATA.ALT==2, DATA.ALT==3,...
%     DATA.Area==5,DATA.Area==7,DATA.Area==10,DATA.Area==15,DATA.Area==25,...
%     DATA.Length==3,DATA.Length==5,DATA.Length==7,DATA.Length==10,DATA.Length==20,...
%     DATA.Termination==1,DATA.Termination==2,DATA.Advisory,...
%     DATA.Subsidy];
% DATA.Xa = [DATA.Xa(:,1:3),matInt([DATA.ALT==1,DATA.ALT==2],DATA.Xa(:,4:8)),...
%     matInt([DATA.ALT==1,DATA.ALT==2,DATA.ALT==3],DATA.Xa(:,9:13)),...
%     matInt([DATA.ALT==1,DATA.ALT==2,DATA.ALT==3],DATA.Xa(:,14:15)),...
%     matInt([DATA.ALT==1,DATA.ALT==2,DATA.ALT==3],DATA.Xa(:,16)),...
%     DATA.Xa(:,end)];
%
% EstimOpt.NamesA = {...
%     'ASC - set aside';'ASC - catch crops';'ASC - fertilization';...
%     'Area - 5 (vs. 1) - set aside';'Area - 7 (vs. 1) - set aside';'Area - 10 (vs. 1) - set aside';'Area - 15 (vs. 1) - set aside';'Area - 25 (vs. 1) - set aside';...
%     'Area - 5 (vs. 1) - catch crops';'Area - 7 (vs. 1) - catch crops';'Area - 10 (vs. 1) - catch crops';'Area - 15 (vs. 1) - catch crops';'Area - 25 (vs. 1) - catch crops';...
%     'Length - 3 (vs. 1) - set aside';'Length - 5 (vs. 1) - set aside';'Length - 7 (vs. 1) - set aside';'Length - 10 (vs. 1) - set aside';'Length - 20 (vs. 1) - set aside';...
%     'Length - 3 (vs. 1) - catch crops';'Length - 5 (vs. 1) - catch crops';'Length - 7 (vs. 1) - catch crops';'Length - 10 (vs. 1) - catch crops';'Length - 20 (vs. 1) - catch crops';...
%     'Length - 3 (vs. 1) - fertilization';'Length - 5 (vs. 1) - fertilization';'Length - 7 (vs. 1) - fertilization';'Length - 10 (vs. 1) - fertilization';'Length - 20 (vs. 1) - fertilization';...
%     'Termination with refund - set aside';'Termination without refund - set aside';...
%     'Termination with refund - catch crops';'Termination without refund - catch crops';...
%     'Termination with refund - fertilization';'Termination without refund - fertilization';...
%     'Advisory - set aside';...
%     'Advisory - catch crops';...
%     'Advisory - fertilization';...
%     'Subsidy per ha'};

% DATA.Xa = [DATA.ALT==1,DATA.ALT==2, DATA.ALT==3,...
%     matInt([DATA.ALT==1,DATA.ALT==2],[DATA.Area==5,DATA.Area==7,DATA.Area==10,DATA.Area==15,DATA.Area==25]),...
%     DATA.Length.*[DATA.ALT==1,DATA.ALT==2,DATA.ALT==3],...
%     DATA.Termination==1,DATA.Termination==2,DATA.Advisory,...
%     DATA.Subsidy];
% EstimOpt.NamesA = {...
%     'ASC - set aside';'ASC - catch crops';'ASC - fertilization';...
%     'Area - 5 (vs. 1) - set aside';'Area - 7 (vs. 1) - set aside';'Area - 10 (vs. 1) - set aside';'Area - 15 (vs. 1) - set aside';'Area - 25 (vs. 1) - set aside';...
%     'Area - 5 (vs. 1) - catch crops';'Area - 7 (vs. 1) - catch crops';'Area - 10 (vs. 1) - catch crops';'Area - 15 (vs. 1) - catch crops';'Area - 25 (vs. 1) - catch crops';...
%     'Length - set aside'; 'Length - catch crops';'Length - fertilization';...
%     'Termination with refund';'Termination without refund';...
%     'Advisory';...
%     'Subsidy per ha'};
%
% DATA.Xa = [DATA.ALT==1,DATA.ALT==2, DATA.ALT==3,...
%     matInt([DATA.ALT==1,DATA.ALT==2],[DATA.Area==5,DATA.Area==7,DATA.Area==10,DATA.Area==15,DATA.Area==25]),...
%     DATA.Length.*[DATA.ALT==1,DATA.ALT==2,DATA.ALT==3],...
%     DATA.Termination==1,DATA.Termination==2,DATA.Advisory,...
%     DATA.Subsidy];
% EstimOpt.NamesA = {...
%     'ASC - set aside';'ASC - catch crops';'ASC - fertilization';...
%     'Area - 5 (vs. 1) - set aside';'Area - 7 (vs. 1) - set aside';'Area - 10 (vs. 1) - set aside';'Area - 15 (vs. 1) - set aside';'Area - 25 (vs. 1) - set aside';...
%     'Area - 5 (vs. 1) - catch crops';'Area - 7 (vs. 1) - catch crops';'Area - 10 (vs. 1) - catch crops';'Area - 15 (vs. 1) - catch crops';'Area - 25 (vs. 1) - catch crops';...
%     'Length - set aside'; 'Length - catch crops';'Length - fertilization';...
%     'Termination with refund';'Termination without refund';...
%     'Advisory';...
%     'Subsidy per ha'};

DATA.Xa = [matInt([DATA.ALT==1,DATA.ALT==2],[DATA.Area==1,DATA.Area==5,DATA.Area==7,DATA.Area==10,DATA.Area==15,DATA.Area==25]),...
    DATA.ALT==3,...
    matInt([DATA.ALT==1,DATA.ALT==2,DATA.ALT==3],[DATA.Length==3,DATA.Length==5,DATA.Length==7,DATA.Length==10,DATA.Length==20]),...
    matInt([DATA.ALT==1,DATA.ALT==2,DATA.ALT==3],[DATA.Termination==1,DATA.Termination==2]),...
    matInt([DATA.ALT==1,DATA.ALT==2,DATA.ALT==3],DATA.Advisory),...
    DATA.Subsidy];

EstimOpt.NamesA = {...
    'Set aside - 1%';'Set aside - 5%';'Set aside - 7%';'Set aside - 10%';'Set aside - 15%';'Set aside - 25%';...
    'Catch crops - 1%';'Catch crops - 5%';'Catch crops - 7%';'Catch crops - 10%';'Catch crops - 15%';'Catch crops - 25%';...
    'Fertilization - 100%';...
    'Length - 3 (vs. 1) - set aside';'Length - 5 (vs. 1) - set aside';'Length - 7 (vs. 1) - set aside';'Length - 10 (vs. 1) - set aside';'Length - 20 (vs. 1) - set aside';...
    'Length - 3 (vs. 1) - catch crops';'Length - 5 (vs. 1) - catch crops';'Length - 7 (vs. 1) - catch crops';'Length - 10 (vs. 1) - catch crops';'Length - 20 (vs. 1) - catch crops';...
    'Length - 3 (vs. 1) - fertilization';'Length - 5 (vs. 1) - fertilization';'Length - 7 (vs. 1) - fertilization';'Length - 10 (vs. 1) - fertilization';'Length - 20 (vs. 1) - fertilization';...
    'Termination with refund - set aside';'Termination without refund - set aside';...
    'Termination with refund - catch crops';'Termination without refund - catch crops';...
    'Termination with refund - fertilization';'Termination without refund - fertilization';...
    'Advisory - set aside';...
    'Advisory - catch crops';...
    'Advisory - fertilization';...
    'Subsidy per ha (1000 EUR)'};

DATA.Xa = [matInt([DATA.ALT==1,DATA.ALT==2],[DATA.Area==1,DATA.Area==5,DATA.Area==7,DATA.Area==10,DATA.Area==15,DATA.Area==25]),...
    DATA.ALT==3,...
    matInt([DATA.ALT==1,DATA.ALT==2,DATA.ALT==3],[DATA.Length]),...
    matInt([DATA.ALT==1,DATA.ALT==2,DATA.ALT==3],[DATA.Termination==1,DATA.Termination==2]),...
    matInt([DATA.ALT==1,DATA.ALT==2,DATA.ALT==3],DATA.Advisory),...
    DATA.Subsidy];

EstimOpt.NamesA = {...
    'Set aside - 1%';'Set aside - 5%';'Set aside - 7%';'Set aside - 10%';'Set aside - 15%';'Set aside - 25%';...
    'Catch crops - 1%';'Catch crops - 5%';'Catch crops - 7%';'Catch crops - 10%';'Catch crops - 15%';'Catch crops - 25%';...
    'Fertilization - 100%';...
    'Length (years) - set aside';...
    'Length (years) - catch crops'; ...
    'Length (years) - fertilization'; ...
    'Termination with refund - set aside';'Termination without refund - set aside';...
    'Termination with refund - catch crops';'Termination without refund - catch crops';...
    'Termination with refund - fertilization';'Termination without refund - fertilization';...
    'Advisory - set aside';...
    'Advisory - catch crops';...
    'Advisory - fertilization';...
    'Subsidy per ha (1000 EUR)'};

DATA.Xa = [DATA.ALT==1,DATA.ALT==2, DATA.ALT==3,...    
    (DATA.ALT==1).*[DATA.Area-1],...
    (DATA.ALT==2).*[DATA.Area-1],...
    (DATA.ALT==1).*(DATA.Length-1),...
    (DATA.ALT==2).*(DATA.Length-1),...
    (DATA.ALT==3).*(DATA.Length-1),...
    DATA.Termination==1,DATA.Termination==2,...
    DATA.Advisory,...
    DATA.Subsidy/100];

EstimOpt.NamesA = {...
    'Set aside';'Catch crops';'Fertilization';...
    'Set aside (additional % over 1)';...
    'Catch crops (additional % over 1)';...    
    'Length (additional years over 1) - Set aside';...
    'Length (additional years over 1) - Catch crops';...
    'Length (additional years over 1) - Fertilization';...
    'Termination with refund';'Termination without refund'; ...   
    'Advisory'; ...    
    'Subsidy per ha (100 EUR)'};

% % DATA.type_livestock, DATA.type_crop, 
% 'Type - livestock', 'Type - crop', 

DATA.Xm = [DATA.ha_managed, DATA.ha_leased, DATA.SGM, DATA.SGM_NaN, DATA.DJP, DATA.DJP_0, DATA.Pig_Farm, DATA.Cow_Farm, DATA.organic_all | DATA.organic_part];
%     DATA.exp_buffer_strips, DATA.exp_wetlands,DATA.exp_red_fert,DATA.exp_set_aside,DATA.exp_fert_sens,DATA.exp_winter_crops,DATA.exp_catch_crops,DATA.exp_red_till,DATA.exp_red_animal,DATA.exp_energy_crops,DATA.exp_afforest]; %,DATA.exp_none
EstimOpt.NamesM = {'Farmed land managed (100 ha)','Farmed land leased (100 ha)', 'Income (100,000 EUR/year)', 'Income missing', 'Livestock units (norm.)', 'No livestock', 'Pig farm', 'Cow farm', 'Organic'};
%     'Experience - buffer strips','Experience - wetland conserv.','Experience - reduced fertilization','Experience - set aside','Experience - fertilizers application','Experience - winter crops','Experience - catch crops','Experience - reduced tillage','Experience - reduced livestock','Experience - energy crops','Experience - afforestation'};

DATA.Xm = [DATA.ha_managed, DATA.ha_leased, DATA.SGM, DATA.SGM_NaN, DATA.DJP, DATA.DJP_0, DATA.Pig_Farm, DATA.Cow_Farm, DATA.organic_all | DATA.organic_part, ...
    DATA.EE, DATA.FI, DATA.PL, DATA.SE];
%     DATA.exp_buffer_strips, DATA.exp_wetlands,DATA.exp_red_fert,DATA.exp_set_aside,DATA.exp_fert_sens,DATA.exp_winter_crops,DATA.exp_catch_crops,DATA.exp_red_till,DATA.exp_red_animal,DATA.exp_energy_crops,DATA.exp_afforest]; %,DATA.exp_none
EstimOpt.NamesM = {'Farmed land managed (100 ha)','Farmed land leased (100 ha)', 'Income (100,000 EUR/year)', 'Income missing', 'Livestock units (norm.)', 'No livestock', 'Pig farm', 'Cow farm', 'Organic',...
    'EE', 'FI','PL','SE'};
%     'Experience - buffer strips','Experience - wetland conserv.','Experience - reduced fertilization','Experience - set aside','Experience - fertilizers application','Experience - winter crops','Experience - catch crops','Experience - reduced tillage','Experience - reduced livestock','Experience - energy crops','Experience - afforestation'};


%% ****************************  specifying input ****************************

try
% for i = 1:5   
    
DATA.filter = true(size(DATA.Y)); %DATA.PL; %true(size(DATA.Y)); %DATA.PL; %true(size(DATA.Y)); % true(size(DATA.Y)); % DATA.EE;%

% eval(['DATA.filter = DATA.',countries{i},';']);
% eval(['EstimOpt.ProjectName = ''',countries{i},'''',';']);
% EstimOpt.BActive = [];
% INPUT = [];

EstimOpt.ProjectName = 'joint';
EstimOpt.ProjectName = 'Xm+ctr';

INPUT.Y = DATA.Y(DATA.filter);
INPUT.Xa = DATA.Xa(DATA.filter,:);
INPUT.Xm = DATA.Xm(DATA.filter,:);

INPUT.W = DATA.Nationalweight(DATA.filter);
INPUT.W = DATA.Totalweight(DATA.filter);


EstimOpt.WTP_space = 1;
EstimOpt.RealMin = 1;

% INPUT.MissingInd = DATA.Missing(DATA.filter);


%% ****************************  sample characteristics ****************************


EstimOpt.NCT = 8; %*3; % Number of choice tasks per person
EstimOpt.NAlt = 4; % Number of alternatives
EstimOpt.NP = length(INPUT.Y)/EstimOpt.NCT/EstimOpt.NAlt;


%% **************************** estimation and optimization options ****************************

% EstimOpt.eps = 1.e-12; % overall precision level

[INPUT, Results, EstimOpt, OptimOpt] = DataCleanDCE(INPUT,EstimOpt);

EstimOpt.NRep = 1e4; % number of draws for numerical simulation
% OptimOpt.MaxIter = 1e3; % maximum number of iterations

% OptimOpt.Algorithm = 'trust-region'; %'quasi-newton'; % 'trust-region'
% EstimOpt.NumGrad = 1; % 1
% OptimOpt.GradObj = 'on'; % 'off'
% OptimOpt.FinDiffType = 'central'; % 'forward'
% OptimOpt.Hessian = 'user-supplied'; % 'off'
% EstimOpt.HessEstFix = 1; % 0 = use optimization Hessian, 1 = use jacobian-based (BHHH) Hessian, 2 - use high-precision jacobian-based (BHHH) Hessian 3 - use numerical Hessian

% EstimOpt.DRAWSkeep = 1;


%% *************************** MNL ********************************

% EstimOpt.RealMin = 1;

% joint: 
B_backup = [-3.29781828530438;-1.39031051439304;-2.63557006361350;-0.00717389154499697;4.73550326616880e-05;-0.137237570953765;-0.114593935434187;-0.103139509831102;0.224765429822611;0.921122392767603;0.310239532197131;0.200145071656222];

% Xm:
B_backup = [B_backup;zeros(size(INPUT.Xa,2)*size(INPUT.Xm,2),1)];
B_backup = [-2.34516007733046;-1.79719981784678;-4.27698949043597;-0.0164158742320906;-0.0473882246394796;-0.144893220289600;-0.183084656435541;-0.192459613621410;0.523259470322591;1.42255891143871;0.409663072764788;0.245276444558301;0.372536670314776;0.542829722915705;1.11907330691675;0.00821372856813042;-0.00915345986505959;-0.0162887519477723;0.0180297089529257;0.00544073376929354;-0.168391601599821;-0.326702742564085;0.0342657527830239;-0.00892482950920211;-1.34352584279331;-0.519656777326707;-1.32549293081844;-0.0282618300510033;0.000147708657879647;0.0742951276484636;0.0132773123069902;-0.0353286306664996;-0.253572552325290;1.00954674772924;-0.262963359104589;-0.00168753684146587;-0.595830845674372;1.45783653385790;1.24657778713627;0.0130577651076536;0.0131973395941119;0.0401681408066902;0.0288479372606421;0.0127185351765115;0.0485894629573569;-0.752577608004011;-0.187360002967119;-0.00840821464861457;-1.55841183619403;-2.05322208986722;-0.227948568329169;-0.0129534311164364;0.0129059334430036;0.114058772414185;0.0910628358853821;0.0496746838624396;0.856525935720151;-0.322750640476010;0.00576820342412951;0.0559822309403833;0.817603774212446;-0.232056287864536;0.456969788095585;-0.0311802511337400;-0.0322758330134833;-0.0549077884419961;0.0108739182757456;-0.0173186885391199;-0.378739146773810;-0.294438715449375;-0.254593909883271;-0.00151249695653013;0.0561583977531809;0.356258553289134;1.06138017017820;0.0633128597037706;0.0633735583492350;-0.00241707735468904;-0.0239637838061058;0.138461181287819;-0.482733926138902;0.129733427437115;0.122313403707414;-0.0684803507588952;-0.0492700129390600;1.25913947257936;1.43362209921751;-0.00605594862509998;0.0372149359697795;0.0493376906655867;0.0425306530384521;0.132439804461756;-0.510369998969353;-0.785901691180579;-0.0101027224487316;0.109263589475949;-1.30466584759330;-0.672164758728195;0.621047588400323;0.0118987191581183;0.0640173397238405;-0.0731457132679825;0.0521574202147628;-0.0240402506255439;0.226136395427441;0.225635390242466;0.0653982935413246;-0.0920029339593028;-1.22956201467365;-0.336235437597848;-2.47208653822050;0.00621886338029535;-0.0487740179361933;-0.00872822509417134;-0.0439539700705510;-0.0899481120893637;-0.0253264919830398;-0.0990889385218212;-0.373337464923441;0.00533215263634607];
B_backup = [B_backup; zeros(4*size(INPUT.Xa,2),1)];

Results.MNL = MNL(INPUT,Results,EstimOpt,OptimOpt);


%% *************************** MXL_d ********************************

EstimOpt.FullCov = 0;

% DK:
% B_backup = [-0.0349566051965658;-0.0129637323258389;-0.00523727615815551;-0.0487996476334234;-0.0280395028552864;-0.0139516763723196;-0.0112967597995345;0.0536923140811667;-0.00841014929980102;2.04796601339293;0.0434206823916165;0.0299717253909541;0.00622993781184754;0.0407267571423950;0.0447653223407516;0.0171446438106390;0.196404574045973;0.123466596727890;0.0847539934132648;1.21885278454352];
% FI:
% B_backup = [-0.00550517326613201;-0.0112422263165636;-0.00198782132442944;-0.0149938838689936;-0.0176813749275114;-0.00795699591460820;-0.0342286629339949;-0.0150103298624070;0.000811365217698457;2.68156910449734;0.0142596596335822;0.0147376971927865;0.00287545862556876;0.0243956715765274;0.0233858597556348;0.00582356743826947;0.0549155697042995;0.106235389048494;0.0426101395380960;1.20335483835178];
% EE:
% B_backup = [-0.0170123593143244;-0.0207617685599569;-0.00729240510447636;-0.0268846598294267;-0.0182298552448782;-0.0165162664145929;-0.200756671268170;-0.0388544601549004;0.109311956365702;2.27253237717013;0.0317002038968147;0.0310323518017234;0.0100981614666504;0.0700571087359486;0.0719638882851745;0.00865354870530110;-0.107010883483971;-0.172862287052656;-0.198989104300539;3.86227506078398];
% PL:
% B_backup = [-0.0227994589631022;-0.00752809375654613;-0.00250420937739480;-0.0470243319202661;-0.0252917722708609;-0.0105943949111152;0.00167921445061173;0.0614157769327253;0.00347939744944765;2.05228868801068;0.0325581752340657;0.0320286612465720;0.00564941343797227;0.0393951073678530;0.0458801467598029;0.0120370435314692;-0.147005525663555;0.120125444473435;0.0633079298976610;1.53828978567479];
% SE:
% B_backup = [-0.00772945562072286;-0.0107754311760597;-0.00348885152420480;-0.0223757017647313;-0.0338517237467447;-0.00296692079447012;-0.0533788713487571;-0.00354477356721508;0.0150467811605085;2.54956271776405;0.0171404234351732;0.0138320503659881;0.00426759313175982;0.0366235272734620;0.0338358656711739;0.00479014443173838;0.0955340784895980;0.0862835952750528;0.0683638971169604;1.21910446537573];

% joint: 
B_backup = [-3.40793078077311;-1.98049417254245;-3.23677582150224;-0.0388288295155180;0.00792518183174252;-0.168585295380327;-0.105724640654401;-0.0902371390115743;0.233874739697491;0.810945137083976;0.192372002478027;-0.125646531476715;4.86274017004791;5.26028244409474;5.58865573263585;0.163649345671718;0.0107346552577609;0.186567972181884;0.161802332965326;0.138907281737038;0.934559347920775;1.07496197777861;0.579388127600615;1.59784056705203];

% Xm:
B_backup = [B_backup; Results.MNL.bhat(size(INPUT.Xa,2)+1:end)];
B_backup = [-2.61312704947551;-1.91457994288372;-3.73239167921982;0.0450160191037539;0.0102744901774630;-0.171520953374057;-0.166942885043633;-0.196669779812849;0.0372229377876136;0.756307863109886;0.0942553963509145;0.604780342946893;4.65765693524967;5.56200483419971;6.07892472453799;0.147421595474114;0.0482142050566448;0.188160891423534;0.177932235251209;0.118434933006199;0.914214221063197;1.20115777451387;0.566149172010492;2.15633468309481;0.437100098256755;0.226472987478449;0.417155674097496;-0.0130116719817744;-0.00595098937642316;-0.0136231504986186;-0.0190415929657339;-0.00628085668600380;-0.351909884945074;-0.423243396106584;0.0781680857806829;-0.157927047458472;-1.12586854296528;-0.290639681610119;-0.300037162045416;0.0171461816404106;-0.0180519758306609;0.0280412493164735;0.0601810207896791;-0.0185664032513745;-0.0158728714147764;0.561543277210346;0.0314405886404048;0.0574429339866350;-0.368291170579753;0.370873066711806;-0.199933170009199;-0.0618962564823072;-0.00800350611287921;-0.00363490403587602;0.0390578750060399;0.0237787779198651;0.525722742949350;0.133750808926573;0.146728645160143;-0.0181931057827228;-1.45871038974976;-2.22582817683559;-0.107989158502530;-0.0569084614719407;-0.0350626936532118;0.0625386357552519;0.116711849709130;-0.0119029989048733;0.492938395423298;-0.138910016958614;0.162029832591205;-0.145745976599990;0.668472583703579;-0.312281819587018;0.513448953329692;-0.0424337749337699;0.000692278408671786;-0.0319489755374438;-0.0244631817502534;0.0195043550801971;-0.471302871133448;-0.335606786471862;-0.278447711321416;-0.00629170415206280;-0.0313746961547003;-0.0252263471559427;0.938946812483769;-0.0367430754120731;0.0156999997965042;0.00991986988170350;0.0111161884340157;0.128060522588681;0.330009753970983;0.148400054977267;-0.113542730025574;-0.269736769521423;-0.986817431554852;1.17719087623450;1.41581869833088;-0.0385947983483038;0.0201119179133569;0.0493298265865688;0.0509284231275676;0.130764401710655;-0.223104999421477;-0.468949560593262;-0.0309669508008771;-0.491644712026585;-1.30411300921059;-0.766760827138335;0.730096355870729;-0.0357434881053686;0.0386052352543252;-0.0226557695280409;0.0528285787302069;0.0413504902114393;0.729919190472803;0.556880161262621;0.127407717195007;-0.354101454569383;-0.641867022009568;0.108522961480859;-3.38420678145798;0.0274587000873170;-0.0407297079493406;0.00493636632666944;0.0108020703859888;0.0107306513268780;-0.300975223306807;-0.182128343541591;-0.122308632891336;0.331212654151510];
% + ctr: 
B_backup = [B_backup; zeros(4*size(INPUT.Xa,2),1)];
B_backup = [-3.00114275391042;-1.82001409524242;-4.54546015747630;0.0438269122096542;-0.0522999772528326;-0.300019951003608;-0.216964414483263;-0.235656128086556;0.622621801998110;1.13991475121893;-0.0247755164723647;0.427827436707409;4.56863413853476;5.38570063977928;5.99789956537256;0.146612203991763;0.0445783891157570;0.186366953837788;0.170449952611444;0.119794396916662;0.886372887565610;1.13117228108501;0.579579613448340;2.23521124321744;0.424237014080699;0.154153082288068;0.345522059639785;-0.0153838581660981;-0.00802590523284919;-0.0127045764683426;-0.0163144414056520;0.00326713345638781;-0.377988349971489;-0.444335839779856;0.0847081321408316;-0.166826138091472;-1.27777376447391;-0.118894270846319;0.268868612312846;0.0440048409596091;-0.0147057670069213;0.0338900055888147;0.0449562442092626;-0.0344861404587828;0.0862225790191791;0.509840046966771;-0.260222710357830;0.147062374571176;-0.451258361739010;-0.133988545645923;-0.355852331583959;-0.0677628634726848;0.0200675387305352;0.0284519529765599;0.0466858645235936;0.0201549364531829;0.484006226699571;0.153859656223829;0.308699611793199;0.00151523061708259;-1.28204619503999;-2.17632219931946;-0.0631257792712228;-0.0671816946573732;-0.0347473235206891;0.0555862780028961;0.0991419050682903;-0.0345543979455879;0.574541159395501;-0.0523215646193643;0.117275305478346;-0.134440179135213;0.828230246190492;-0.111512827055655;0.411933198574675;-0.0410357280662681;-0.00686566998092179;-0.0530117752402335;-0.0235367787890764;0.0123141446938935;-0.476094171517383;-0.317429950973207;-0.197430108766139;-0.00951972565190320;0.0873297326505414;0.160266402320482;0.799228992278248;-0.0535378609892158;0.0163242748465114;-0.00149234948527396;-0.0121537447221244;0.121829523132210;0.402487716105727;0.167533635003218;0.0255467053449470;-0.229861199164010;-0.974311014519570;1.30016037265554;1.48350131466071;-0.0381443305834843;0.0102601439288750;0.0458043222318801;0.0436259729901586;0.117829092748487;-0.230444895212454;-0.539154370447362;-0.00727993388884414;-0.601438367384804;-1.16767259389325;-0.589709881532399;0.669802369287488;-0.0401992036383042;0.0366592289727849;-0.0301532349124267;0.0340075178798778;0.0548264949584156;0.657969644935089;0.535826468999503;0.211738217491119;-0.462527426944156;-0.575108220156102;-0.0180913224034944;-2.88102324634338;0.0356869149884653;-0.0275937474966283;-0.00199587275412460;0.0193165058578891;-0.0326458105936283;-0.379864692613425;-0.313013214393708;-0.119260698960252;0.286245747739570;0.158359390207103;-1.46989017798403;-2.38711584262741;-0.0925811123034789;-0.0159853717509662;0.261003190979277;0.151205069099829;0.0254038622438722;-1.38524345682190;-0.576352398996649;1.07596608715288;-0.503047165157121;0.251086710332555;0.0775171333928173;1.03950329732909;0.0309184896645215;0.00364357835565016;0.173744121113436;0.0842701226234272;0.0441975278407481;-0.974197043454480;-0.824976080235260;-0.0309697332412925;0.251098965566264;0.331208700614557;-0.335396994560111;0.899877149039664;0.00584474013446082;0.0711429306544884;0.134358865388683;0.0886203402815169;0.0420833706055522;-0.535801876312934;-0.309276784438979;0.0112060411963349;0.415911995001984;0.329949001392738;0.529367103542222;-0.0370088693950705;-0.00909068626448667;-0.000637685029469347;0.181708314791513;-0.0241578246554372;0.118439197849427;-0.749604199516237;-0.572587212698102;0.253537380420352;0.341157114925634];


OptimOpt.Algorithm = 'trust-region'; % 'quasi-newton';
OptimOpt.Hessian = 'user-supplied'; % 'off'

Results.MXL_d = MXL(INPUT,Results,EstimOpt,OptimOpt);

OptimOpt.Algorithm = 'quasi-newton';
OptimOpt.Hessian = 'off';

Results.MXL_d = MXL(INPUT,Results,EstimOpt,OptimOpt);


%% *************************** MXL ********************************

% EstimOpt.FullCov = 1;

% DK:
% B_backup = [-0.0238554118645961;-0.00887918788809993;-0.00379470998310121;-0.0441475285049740;-0.0220252540528713;-0.0337589762124832;0.0466285484570501;0.102084089851586;0.00805496508926300;2.04975622219724;0.0330666629108105;0.00855702759495294;0.00281691312956836;0.0203787204176277;0.0188128541988819;0.00295430378295410;0.139935348550763;0.0787254873184041;0.0741240084051817;-0.303190321273360;0.0195045060384090;0.00229779779144326;-0.00761854655693272;0.0207432904286109;0.00657696626744675;0.137707035533008;0.106609915819385;0.0284705071140838;-0.0752607449237514;0.00432615597114051;0.00451889727557501;0.00232627491845137;0.0178150958769357;0.0139362952312734;0.0196779922668956;-0.0271389094373152;-0.120000733007941;0.0265921048667106;0.0133646481913846;0.0161801932190031;0.0373658045435368;0.0217418376302174;-0.00233481924755249;0.221802788359631;0.00949173265880732;0.0101802308260640;0.0497573820984316;0.0620239640791827;-0.00667048799745884;-0.125763311125725;0.0197592842158673;-0.0600801037037323;-0.0949122122677808;-0.0149423768746202;0.270833035703577;0.0250982715079760;-0.0609087300710143;0.0360757900674206;0.582141658504485;0.0325607547822337;0.00352721861328090;-0.0253905720279721;0.0198623718581551;-0.865858746373767;-0.541974289452116];
% FI:
% B_backup = [-0.00376002700950786;-0.00837564241370263;-0.00188625337034408;-0.0164499468577501;-0.0200333453014806;-0.00938162196698915;-0.0197305895529510;0.0333583308541031;0.00948323419626455;2.70677321381368;-0.0118336272233029;-0.0125074445401505;-0.00217536088414101;-0.0206328368384073;-0.0161527973306587;0.000477565191097757;-0.0421826019353021;-0.00537297673170463;-0.0250268380261691;-0.0994350437680245;-0.00835470619789061;-0.00119616290054727;0.00576286420512576;-0.0110311494584226;0.00144767079596614;-0.0104991628695632;-0.0362862007166863;-0.00905231648832848;0.328392723377427;0.00281572812743095;0.00133128292835767;0.00176110032912597;-0.00235213625943153;-0.00861249894974010;-0.0431814776222809;0.00698033300272937;0.454100437896718;0.00335067052691769;0.00770657232581479;0.000418939618941452;-0.00916183995711694;-0.0559966782579065;0.00645587350477300;0.773635272979764;0.00960758069962421;0.00522732063025618;-0.000905922661813571;-0.0470637510796108;-0.0172960743260899;0.517735143354531;-0.00624721952009261;-0.0427801594350594;-0.0156096286094886;0.0137957943735382;-0.465922785844805;0.0167917914604064;0.0298728424967030;-0.0117550552786790;-0.00310241462985922;0.0334041408636486;0.00106440125822481;-0.475323338080038;-0.000572568134034605;-0.217022540071866;-0.00533381881100125];
% EE:
% B_backup = [-0.00332190824458205;-0.00953384000970785;-0.00675138271611087;-0.0430715839837319;-0.0221797570616152;-0.0257301530992223;-0.224033264432853;0.0426129786144490;0.0664937665833478;1.53085445527607;-0.0112241122942078;-0.0192989818045871;-0.0155568150124430;-0.0399772542360927;-0.0478711616098013;0.00654495310598004;0.0791192087866076;0.0187685231782687;-0.129041745444244;0.453064809699338;0.0249877684413595;0.00180761228720194;-0.00591501236359270;0.0268666856648267;0.00596951786308893;0.0534817160838308;0.0201414060140433;0.0458788353721404;-0.449855577012818;-0.00378139878734692;-0.0203668435103215;-0.0372332397672708;-0.0139705409747008;-0.165839699959808;-0.0151230447271681;-0.0308746570881794;-1.72479265899012;0.0591132564077882;0.0242741606321902;0.0240507718178509;0.118896875813781;0.00247151846508768;0.0548743354583384;1.22223580629884;-0.0242930089094815;-0.00709615267595451;0.0303224868616689;0.102246459599591;-0.0361682801908494;-0.400453572896450;0.00986712760779046;0.0674341263634538;-0.0299939882943330;0.0148255693062803;0.656885299687706;0.00724531047510613;-0.135776092792768;-0.0459514629517835;1.42889157995673;-0.0173026814258461;-0.0284611696858508;-0.582188886866470;0.0823628713199238;0.796797296038278;1.00608945855469];
% PL:
% B_backup = [-0.0140327573403737;0.00199812549444441;-0.00127604299266478;-0.0387713912222740;-0.0195389757972140;-0.0228762213494116;0.0667381025288938;0.0927307134105870;0.0265161510396821;2.05145162645075;0.0317553811237706;0.0146929507754849;0.00253308629219576;0.0206872151744504;0.0139822757657391;-0.000671143410076117;0.153361647317127;0.114010514600750;0.0722926537588553;-0.918233688895830;-0.0207627115565827;-0.00110091105812237;0.00921823157811494;-0.0145495066221417;-0.00548868937242857;-0.0534368789648062;-0.0226436076889148;-0.0297879839032526;0.485171949891631;0.00434969697407648;-0.00490832425976022;0.00543161907773412;0.0176812955565018;0.0108379285365620;-0.00737566491565910;0.0140736733843556;0.0422047803898425;0.0177380392809920;0.00742686989405761;0.0106108038023127;0.0541787309679955;0.0307395975755766;0.0140977473969662;0.400537630179924;0.0303076305494237;0.000733526678448849;0.0108631726287929;0.00864857910588484;0.00724709670169647;0.548024266608164;-0.0104869882977853;0.0223822145877542;-0.0408337480904899;-0.0388439935824636;-0.342945418194927;0.0963758764845131;0.106740763721744;0.00850484296176083;-0.809780232837035;-0.0763593915624297;-0.0321220500458216;-0.157455856894077;-0.0256265551129309;-0.506418918490713;0.256728083768411];
% SE:
% B_backup = [-0.00339447665460829;-0.0100541830997587;-0.00360867056855481;-0.0196263643821137;-0.0292028746772082;-0.00446614524223367;-0.00791537417341622;0.0418223500910777;0.0177115331943841;2.50754155968611;0.00623571314826844;0.0120034721198168;0.00205594230458446;0.0214927267358038;0.0236955473044178;0.00170247986779372;0.0436493950663646;0.0115022650779093;0.0561186188396622;-0.306340429118434;-0.00413077707615882;-0.00267609318814782;-0.0168727956846166;-0.0201506296998014;-0.00795889381133290;0.0291163037023132;0.0525456338350473;0.0132133054093742;-0.421367366794338;0.00298571051181571;-0.0130188985627994;-0.00257626636852717;-0.00399666689921161;0.00496449703611317;0.0318963829778775;-0.000109072993685449;0.0306130651516122;0.0299426067821548;-0.00118537165356890;0.00431338656154485;0.0475204584746574;0.00906401993511669;0.00389623076314640;-0.140536069619369;0.0118464944893969;-0.00234011004625928;-0.0201816708351115;-0.0516834383394762;0.00327994987016929;0.371972386339984;0.00538376780379845;-0.0637786055001062;-0.0463726774931314;-0.00658835303889852;0.284325876632153;-0.00136347422166913;-0.00363611992242959;0.00895521963320835;-0.332962316580850;-0.0246823448423210;-0.00875072953404170;-0.280946496807897;0.00996161637883595;-0.423355471998107;0.767195358241160];

% joint: 
% B_backup = [-1.48309364180145;-0.707537653322621;-2.99705405172582;-0.0238948073701156;-0.0376415991108844;-0.140400262421802;-0.169497615357561;-0.115099029326359;0.221642428324155;0.889012912591527;0.235111555013964;-0.217493205756000;6.61224513936221;5.75529890971773;5.33910795328031;0.0227990545462372;0.00588152376808672;0.0363747468868723;0.0454156237235714;0.00983877928767924;-0.0910843841176096;-0.268621045161759;-0.0992842561068616;-0.0436816617881012;3.76874421797783;3.38121088723480;-0.00633477041645196;0.0155595846324149;0.0151502363608741;0.0338025321684028;0.0190283959364671;-0.0229240607038013;0.114115942115602;-0.0674930109771344;0.0908079947524002;4.66336449660475;0.0326918672608571;0.0205491163852486;0.0669383833297175;0.0602463591369070;0.0325861125393636;-0.202255481049983;-0.504718189332752;-0.0447954124127939;0.399902971086824;0.0150917396670116;0.0161517923816936;0.104720975811644;0.0611588402734909;0.0534835425600424;-0.0798008724879365;-0.762196101933755;0.0742190722039185;0.924172356207256;0.0198910477345163;-0.0971943622143112;-0.149229337225307;-0.0447622328331037;0.204126614421593;0.357902177268585;0.0752255111555986;-0.449327809429907;-0.0143971136993956;0.000114620400134617;0.00984885416403294;0.440208359793689;0.636371159222697;-0.00979498500426966;-0.117823211153756;-0.0155693993919214;0.0554737895881302;0.207504461626703;0.146727378332909;-0.150084471896792;0.203814032864698;-0.0174966957607971;-0.252305676970914;-0.0189573590158594;0.0748847928177822;-0.113906224662502;-0.193302115135637;0.0885478415851176;0.119394517369023;-0.0515381985528126;-0.279710752286592;-0.171301610906242;0.235969378964952;0.294927889074864;0.159105032146736;0.633778031263663];

% OptimOpt.Algorithm = 'trust-region'; % 'quasi-newton';
% OptimOpt.Hessian = 'user-supplied'; % 'off'
% 
% Results.MXL = MXL(INPUT,Results,EstimOpt,OptimOpt);
% 
% OptimOpt.Algorithm = 'quasi-newton';
% OptimOpt.Hessian = 'off';
% 
% Results.MXL = MXL(INPUT,Results,EstimOpt,OptimOpt);

% end

sendmail('mik@czaj.org','MATLAB: D1 - done!');
       
catch theErrorInfo
   
    sendmail('mik@czaj.org','MATLAB: D1 - error!',theErrorInfo.message);
    rethrow(theErrorInfo)
    
end
